package com.bjlt.spider.commonhandler;

import com.bjlt.spider.entity.SearchResponseEntity;
import com.bjlt.spider.qunaer.entity.PriceMap;
import com.bjlt.spider.qunaer.entity.QunarRoutings;
import com.bjlt.spider.qunaer.entity.VerifyRedisLog;
import com.bjlt.spider.util.UUIDUtils;
import com.google.common.collect.Lists;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Component;

import java.util.List;

import static java.util.stream.Collectors.toList;

@Component
@Slf4j
public class AirSoucePolicyForOrderHandler extends AbstractHandler {


    @Override
    public List<QunarRoutings> handlerList(List<SearchResponseEntity> list, String cid, QunarRoutings qunarRoutings, String tripType) {
        List<QunarRoutings> QunarRoutingsInSearch = handlerRequest(list, cid, qunarRoutings, tripType);

        String fromAirCode = qunarRoutings.getFromSegments().get(0).getAircraftCode();


        String retAirCode = "";

        if (qunarRoutings.getRetSegments() != null && qunarRoutings.getRetSegments().size() != 0) {
            retAirCode = qunarRoutings.getRetSegments().get(0).getAircraftCode();
        }

        qunarRoutings.setUuid(null);

        qunarRoutings.setData(null);

        qunarRoutings.setFromDate(qunarRoutings.getFromDate());


        if (qunarRoutings.getFromSegments() != null) {
            qunarRoutings.getFromSegments().stream().forEach(t -> {
                t.setAircraftCode("");
                t.setCabinClass(null);
                t.setStopCitiesEntity(null);

                t.setStopCities("");

                t.setDuration(null);


            });
        }


        if (qunarRoutings.getRetDate() != null) {
            if (!"".equals(qunarRoutings.getRetDate())) {
                qunarRoutings.setRetDate(qunarRoutings.getRetDate());
                qunarRoutings.getRetSegments().stream().forEach(t -> {
                    t.setCabinClass(null);
                    t.setAircraftCode("");
                    t.setDuration(null);
                    t.setStopCitiesEntity(null);

                    t.setStopCities("");

                });
            }

        }


        QunarRoutingsInSearch.stream().forEach(t -> {
            t.setUuid(null);

            t.setData(null);


            if (t.getFromSegments() != null) {
                t.getFromSegments().stream().forEach(s -> {
                    s.setStopCities("");
                    s.setCabinClass(null);
                    s.setAircraftCode("");
                    s.setDuration(null);
                    s.setStopCitiesEntity(null);
                });
            }


            if (t.getRetSegments() != null) {
                t.getRetSegments().stream().forEach(s -> {
                    s.setStopCities("");
                    s.setAircraftCode("");
                    s.setCabinClass(null);
                    s.setDuration(null);
                    s.setStopCitiesEntity(null);
                });
            }
        });

        List<QunarRoutings> collect = Lists.newArrayList();
        if (qunarRoutings.getTripType().equals("1")) {
            collect = QunarRoutingsInSearch.stream().filter(t ->

                    t.getFromDate().equals(qunarRoutings.getFromDate())
            ).filter(k -> k.getFromSegments().containsAll(qunarRoutings.getFromSegments()))
                    .collect(toList());


        } else {
            collect = QunarRoutingsInSearch.stream().filter(t ->

                    t.getFromDate().equals(qunarRoutings.getFromDate())
                            && t.getRetDate().equals(qunarRoutings.getRetDate())


            ).filter(k -> k.getFromSegments().containsAll(qunarRoutings.getFromSegments())
            ).filter(k -> k.getRetSegments().containsAll(qunarRoutings.getRetSegments())
            ).collect(toList());

        }


        if (collect != null && collect.size() != 0) {

            List<QunarRoutings> list1 = Lists.newArrayList();

            PriceMap priceMap = qunarRoutings.getPriceMap();

            qunarRoutings.setAdultPrice(priceMap.getAdultPrice());

            qunarRoutings.setAdultTax(priceMap.getAdultTax());

            qunarRoutings.setChildPrice(priceMap.getChildPrice());
            qunarRoutings.setTag(priceMap.getFromTag());
            qunarRoutings.setMaxSeats(priceMap.getMaxSeats());
            qunarRoutings.setChildTax(priceMap.getChildTax());


            qunarRoutings.getFromSegments().stream().forEach(t -> t.setAircraftCode(fromAirCode));


            if (qunarRoutings.getRetSegments() != null && qunarRoutings.getRetSegments().size() != 0) {
                String finalRetAirCode = retAirCode;
                qunarRoutings.getRetSegments().stream().forEach(t -> t.setAircraftCode(finalRetAirCode));

            }


            list1.add(qunarRoutings);

            log.error("---------生单验价成功---------");
            return list1;
        } else {
            log.error("---------生单验价失败---------");
            return null;
        }


    }
}
