package com.bjlt.spider.config;

import com.bjlt.spider.common.RedisKeyNames;
import com.bjlt.spider.entity.ScHbgjCharge;
import com.bjlt.spider.entity.ScRefundHbgjPenalty;

import com.bjlt.spider.hangbanguanjia.refund.service.ScHbgjChargeService;
import com.bjlt.spider.hangbanguanjia.refund.service.ScRefundHbgjPenaltyService;
import com.bjlt.spider.mq.RabbitMQConfig;
import com.bjlt.spider.orderInfo.service.OrOrdertbService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.context.event.ApplicationReadyEvent;
import org.springframework.context.ApplicationListener;
import org.springframework.core.Ordered;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 14:34 2018/1/3
 */
@Component
@Slf4j
public class RefundInitListenner implements ApplicationListener<ApplicationReadyEvent>, Ordered {


    @Autowired
    private ScRefundHbgjPenaltyService refundHbgjPenaltyService;


    @Autowired
    private RedisTemplate<String, Object> redisTemplate;

    @Autowired
    private ScHbgjChargeService hbgjChargeService;

    @Override
    public void onApplicationEvent(ApplicationReadyEvent applicationReadyEvent) {
        log.info("---------初始化退改签库开始---------");

        List<ScRefundHbgjPenalty> scRefundHbgjPenalties = refundHbgjPenaltyService.listScRefundHbgjPenalty(new ScRefundHbgjPenalty());


        redisTemplate.opsForValue().set(RedisKeyNames.REFUND, scRefundHbgjPenalties);

        List<ScHbgjCharge> scHbgjCharges = hbgjChargeService.listScHbgjCharge(new ScHbgjCharge());

        redisTemplate.opsForValue().set(RedisKeyNames.CHARGE, scHbgjCharges);

        log.info("---------初始化退改签库完毕---------");

}

    @Override
    public int getOrder() {
        return Ordered.LOWEST_PRECEDENCE;
    }
}
