package com.bjlt.spider.hangbanguanjia.controller;

import com.alibaba.fastjson.JSONObject;
import com.bjlt.spider.entity.SearchRequestAfterOta;
import com.bjlt.spider.entity.SearchResponseEntity;
import com.bjlt.spider.hangbanguanjia.entity.HbgjEntity;
import com.bjlt.spider.hangbanguanjia.entity.HbgjTrip;
import com.bjlt.spider.interfaces.ControRpc;
import com.bjlt.spider.util.RespEntity;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.google.common.collect.Lists;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.io.IOException;
import java.util.Arrays;
import java.util.List;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 09:50 2017/12/26
 */
@Slf4j
@Component
public abstract class HbgjBaseController {


    @Autowired
    private ControRpc controRpc;

    @Autowired
    private ObjectMapper objectMapper = new ObjectMapper();



    public List<SearchResponseEntity> getResult(HbgjEntity entity){

        //判断航班类型
        List<HbgjTrip> tripList = Arrays.asList(entity.getTripList());

        SearchRequestAfterOta ota = new SearchRequestAfterOta();

        List<SearchResponseEntity> responseEntityArrayList = Lists.newArrayList();



        //单程
        String fromCity = "";
        String toCity = "";
        String fromDate = "";
        String toDate = "";
        HbgjTrip hbgjTrip = tripList.get(0);
        fromCity = hbgjTrip.getFromCity();
        toCity = hbgjTrip.getToCity();
        fromDate = hbgjTrip.getDate();
        String tripType = "";

        if (tripList.size() == 2) {

            HbgjTrip hbgjTripTo = tripList.get(1);
            toDate = hbgjTripTo.getDate();

            if ((fromCity.equals(hbgjTripTo.getToCity())) && toCity.equals(hbgjTripTo.getFromCity())) {
                tripType = "2";
                ota = SearchRequestAfterOta.builder()
                        .adultNum(entity.getAdultsNum())
                        .childNum(entity.getChildrenNum())
                        .fromCity(fromCity)
                        .toCity(toCity)
                        .retDate(toDate)
                        .fromDate(fromDate)
                        .tripType("2")
                        .cid("QUNA")
                        .cache(true)
                        .build();

            }
        } else {
            tripType = "1";
            ota = SearchRequestAfterOta.builder()
                    .adultNum(entity.getAdultsNum())
                    .childNum(entity.getChildrenNum())
                    .fromCity(fromCity)
                    .toCity(toCity)
                    .fromDate(fromDate)
                    .tripType("1")
                    .cache(true)
                    .cid("QUNA")
                    .build();
        }
        RespEntity spiderEntity = null;
        try {
            log.info("开始向控制中心发送search请求{}", ota.toString());
            spiderEntity = controRpc.createSpider(ota);
        } catch (Exception e) {
            e.printStackTrace();
           return null;
        }


        Object attachment = spiderEntity.getAttachment();

        List retList = (List) attachment;

        if (retList == null || retList.size() == 0) {
            return null;
        }


        retList.forEach(t -> {

            String searchEntityString = JSONObject.toJSONString(t);


            try {
                SearchResponseEntity responseEntity = objectMapper.readValue(searchEntityString, SearchResponseEntity.class);


                responseEntityArrayList.add(responseEntity);
            } catch (IOException e) {
                e.printStackTrace();
            }

        });


        log.info("---------拿到搜索服务的结果---------");


        return  responseEntityArrayList;
    }
}
