package com.bjlt.spider.hangbanguanjia.controller;


import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bjlt.spider.hangbanguanjia.entity.HbgjEntity;
import com.bjlt.spider.hangbanguanjia.entity.HbgjRespEntity;
import com.bjlt.spider.hangbanguanjia.entity.HbgjTrip;
import com.bjlt.spider.hangbanguanjia.service.HbgjOrderService;
import com.bjlt.spider.hangbanguanjia.service.HbgjSearchService;
import com.bjlt.spider.qunaer.entity.HbgjOrderRespEntity;
import com.bjlt.spider.utils.LoadParam;
import com.fasterxml.jackson.databind.ObjectMapper;
import lombok.extern.slf4j.Slf4j;
import org.jdom2.Document;
import org.jdom2.Element;
import org.jdom2.input.SAXBuilder;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

@RestController
@RequestMapping(value = "/variflight")
@Slf4j
public class HbgjController {


    @Autowired
    private HbgjSearchService searchService;


    @Autowired
    private HbgjOrderService orderService;


    private ObjectMapper objectMapper = new ObjectMapper();


    @PostMapping(value = "search", consumes = MediaType.TEXT_PLAIN_VALUE)
    public HbgjRespEntity search(HttpServletRequest request) throws Exception {


        log.info("收到航班管家请求search{}");

        String param = LoadParam.read(request.getInputStream());
        JSONObject object = JSONObject.parseObject(param);
        String childrenNum = object.getString("childrenNum");
        String adultsNum = object.getString("adultsNum");
        String cabinClass = object.getString("cabinClass");
        JSONArray tripList = object.getJSONArray("tripList");


        HbgjEntity entity = new HbgjEntity();

        entity.setAdultsNum(Integer.valueOf(adultsNum));


        entity.setChildrenNum(Integer.valueOf(childrenNum));

        entity.setCabinClass(cabinClass);
        List<HbgjTrip> hbgjTrips = new ArrayList<>();

        for (Object o : tripList) {
            HbgjTrip hbgjTrip = objectMapper.readValue(o.toString(), HbgjTrip.class);
            hbgjTrip.setDate( hbgjTrip.getDate().replace("-",""));
            hbgjTrips.add(hbgjTrip);
        }



        entity.setTripList(hbgjTrips.toArray(new HbgjTrip[]{}));


        log.info("航班管家搜索参数{}",entity.toString());
        return searchService.search(entity);
    }


    @PostMapping(value = "verify",consumes = MediaType.TEXT_PLAIN_VALUE)
    public HbgjRespEntity verify(HttpServletRequest request) throws Exception {

        String param = LoadParam.read(request.getInputStream());
        JSONObject object = JSONObject.parseObject(param);
        String childrenNum = object.getString("childrenNum");
        String adultsNum = object.getString("adultsNum");
        String cabinClass = object.getString("cabinClass");

        String confirmPara = object.getString("confirmPara");


        JSONArray tripList = object.getJSONArray("tripList");


        HbgjEntity entity = new HbgjEntity();

        entity.setAdultsNum(Integer.valueOf(adultsNum));

        entity.setConfirmPara(confirmPara);

        entity.setChildrenNum(Integer.valueOf(childrenNum));

        entity.setCabinClass(cabinClass);
        List<HbgjTrip> hbgjTrips = new ArrayList<>();

        for (Object o : tripList) {
            HbgjTrip hbgjTrip = objectMapper.readValue(o.toString(), HbgjTrip.class);
            hbgjTrip.setDate( hbgjTrip.getDate().replace("-",""));
            hbgjTrips.add(hbgjTrip);
        }



        entity.setTripList(hbgjTrips.toArray(new HbgjTrip[]{}));


        return searchService.verify(entity);
    }

    @PostMapping(value = "order", produces={"application/xml; charset=UTF-8"})
    public HbgjOrderRespEntity order(HttpServletRequest request) {



        return orderService.bookOrder(request);
    }



    @PostMapping(value = "verifyBeforePay", produces={"application/xml; charset=UTF-8"})
    public HbgjOrderRespEntity verifyBeforePay(HttpServletRequest request) {



        return orderService.verifyBeforePay(request);
    }

}
