package com.bjlt.spider.hangbanguanjia.entity;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 14:17 2017/12/18
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class Fare {
    /**
     * 成人不含税价
     */
    private int adultPrice;
    /**
     * 成人税费
     */
    private int adultTax;
    /**
     * 儿童不含税价 N
     */
    private int childPrice;

    /**
     * 儿童税费 N
     */
    private int childTax;
    /**
     * 货币，人民币为 CNY
     */
    private String currency;

    /**
     * 舱位列表
     */
    private Cabin[] cabins;
    /**
     * 成人票规
     */
    private Penalty adultPenalty;

    /**
     * 儿童票规，如无则同成人票规 N
     */
    private Penalty childPenalty;

    /**
     * 票价限制条件 N
     */
    private Restriction restriction;

    /**
     * 发票类型
     * 1 行程单
     * 2 发票
     * 3 行程单\发票两者皆有  N
     */
    private int tags;
    /**
     * 强制保险费用，如果有  N
     */
    private int ins;
    /**
     * 验价报文所需请求参数，gzip+base64 压缩  N
     */
    private String confirmPara;
    /**
     * 下单 URL，跳转下单时提供
     */
    private String orderUrl;
    /**
     * 对应服务条款
     * 1) COMMON:公布运价 2) PREPAY:私有运价
     * 3) LCC:廉价航空
     * 4) ABROAD:境外票
     * 5) OFFLINE:包机切位
     * 6) C2P:公布转私有,包括私转“私”,允许自定义退改
     */
    private String productType;
    /**
     * 预计出票时间(小时)
     */
    private int ticketTime;
}
