package com.bjlt.spider.hangbanguanjia.entity;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.util.List;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 15:49 2017/12/15
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class Flight implements Cloneable,Serializable{
    private static final long serialVersionUID = 4613480856187150578L;
    /**
     * 航班 uuid
     */
    @JsonIgnore
    private String uuid;

    /**
     * 航班 ID 号，用于价格关联
     */
    private Integer id;
    /**
     * 航班号
     */
    private String fn;
    /**
     * 飞机代码
     */
    private String aircraftCode;
    /**
     * 起飞机场三字码
     */
    private String org;
    /**
     * 到达机场三字码
     */
    private String dst;
    /**
     * 起飞航站楼，非必填
     */
    private String orgt;
    /**
     * 到达航站楼，非必填
     */
    private String dstt;
    /**
     * 餐食信息，如 B(早餐)/L(午餐)/D(晚餐) /S(零食)/1(有)/0(无)
     */
    private String meal;
    /**
     * 起飞时间，格式为 yyyy-MM-dd HH:mm
     */
    private String dt;
    /**
     * 到达时间，格式同上
     */
    private String at;
    /**
     * 代码共享航班实际承运航班 非必填
     */
    private String optfn;
    /**
     * 航班准点率,0-100 非必填
     */
    private String proximateRate;

    /**
     * 1-提供 wifi，0-不提供(默认) 非必填
     */
    private String wifi;

    /**
     * 经停站，一般为空列表
     */
    private Stop[] stops;


    /**
     * 本地标记航班类型 与平台无关
     */
    @JsonIgnore
    private String tripType;

    @JsonIgnore
    private String leftSeats;

    @JsonIgnore
    private String myCabin;

    @JsonIgnore
    private List<String> myCabins;

    @Override
    public Flight clone() throws CloneNotSupportedException {
        Flight flight = null;

        try {
            flight = (Flight)super.clone();
        } catch (CloneNotSupportedException var3) {
            var3.printStackTrace();
        }

        return flight;
    }
}
