package com.bjlt.spider.hangbanguanjia.entity;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import java.io.Serializable;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 17:06 2018/1/11
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@XmlRootElement(name = "createOrderResponse")
@XmlAccessorType(XmlAccessType.NONE)
public class HbgjFlightSegment implements Serializable{
    private static final long serialVersionUID = -4075414938039171697L;


    /**
     * 去程|回程，OB-去程，IB-回程
     */
    @XmlElement
    private String tripType;

    /**
     * 行程顺序，1-航段第一程，去程和回程都从 1 开始
     */
    @XmlElement
    private String tripSeq;
    /**
     * 起飞机场三字码
     */
    @XmlElement
    private String departCityCode;

    /**
     * 到达机场三字码
     */
    @XmlElement
    private String arriveCityCode;

    /**
     * 航班号
     */
    @XmlElement
    private String flyno;

    /**
     * 舱位
     */
    @XmlElement
    private String cabin;

    /**
     * 成人票面价
     */
    @XmlElement
    private String price;

    /**
     * 儿童票面价
     */
    @XmlElement
    private String chdPrice;

    /**
     * 燃油
     */
    @XmlElement
    private String rateFee;

    /**
     * 机建
     */
    @XmlElement
    private String airportFee;

    /**
     * 儿童燃油
     */
    @XmlElement
    private String chdRateFee;

    /**
     * 儿童机建
     */
    @XmlElement
    private String chdAirportFee;

    /**
     * 基础舱位
     */
    @XmlElement
    private String baseCabin;

    /**
     * 起飞日期，yyyy-MM-dd
     */
    @XmlElement
    private String flydate;

    /**
     * 到达日期，yyyy-MM-dd
     */
    @XmlElement
    private String arrdate;

    /**
     * 起飞时间，hh:mm
     */
    @XmlElement
    private String deptime;

    /**
     * 到达时间，hh:mm
     */
    @XmlElement
    private String arrtime;

    /**
     * 退票规则
     */
    @XmlElement
    private String ruleRefund;

    /**
     * 改签规则
     */
    @XmlElement
    private String ruleChange;





}
