package com.bjlt.spider.hangbanguanjia.entity;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 14:29 2017/12/18
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class Restriction {
    /**
     * 最小预订人数
     */
    private int minPassenger;

    /**
     * 最大预订人数
     */
    private int maxPassenger;

    /**
     * 年龄限制下限，0 表示不限制
     */
    private int minAge;
    /**
     * 年龄限制上限，0 表示不限制
     */
    private int maxAge;

    /**
     * 允许的国籍两字码，可多个，用|分隔，如 CN|US，不 填表示全部
     */
    private String allowedNationality;

    /**
     * 不允许的国籍两字码，可多个，用|分隔，如 CN|US， 最 终 结 果 为 allowedNationality 除 去 restrictedNationality
     */
    private String restrictedNationality;

    /**
     * 对于旅客类型的限制说明
     */
    private String passengerType;
}
