package com.bjlt.spider.mq;

import com.bjlt.spider.utils.ByteUtil;
import com.rabbitmq.client.Channel;
import com.rabbitmq.client.Connection;
import com.rabbitmq.client.ConnectionFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 14:12 2018/1/15
 */
@Slf4j
@Service
public class BaseMqSender {

    @Autowired
    private ConnectionFactory factory;

    public void send(Object target,String queneName) {

        try {
            Connection connection = factory.newConnection();
            Channel channel = connection.createChannel();

            channel.queueDeclare(queneName, true, false, false, null);

            channel.basicPublish("", queneName, null, ByteUtil.getBytes(target));


            channel.close();
            connection.close();


        } catch (Exception e) {
            e.printStackTrace();
            log.info("发送失败{}",target);
        }
    }

}
