package com.bjlt.spider.policy.dao.impl;

import com.bjlt.spider.policy.dao.GlobalRulesDao;
import com.bjlt.spider.policy.entity.ScGlobalRegulate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Repository
public class GlobalRulesDaoImpl implements GlobalRulesDao {

    @Autowired
    private JdbcTemplate jdbcTemplate;

    @Override
    public List<ScGlobalRegulate> listPageScGlobalRegulate(ScGlobalRegulate scGlobalRegulate) {
        StringBuffer s=new StringBuffer();
        String select = "select id,adult_price,child_price, cid,time_start, time_end,source_name, update_time, add_time, status, edit_user from sc_global_regulate ";
        s.append(select );
        Map<String,Object> m=map(scGlobalRegulate);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        s.append(where);
        RowMapper<ScGlobalRegulate> rowMapper = new BeanPropertyRowMapper<>(ScGlobalRegulate.class);
        List<ScGlobalRegulate> list = jdbcTemplate.query(s.toString(), rowMapper,m.values().toArray());
        Integer count = count(where, m.values().toArray());

        if (list.size() != 0){
            list.get(0).setTotal(count);
        }
        return list;
    }

    private static Map<String,Object> map(ScGlobalRegulate scGlobalRegulate) {
        Map<String,Object> map=new HashMap();
        if (scGlobalRegulate.getId() != null) {
            map.put("id",scGlobalRegulate.getId());
        }
        if (scGlobalRegulate.getCid() != null && !scGlobalRegulate.getCid().equals("")) {
            map.put("cid",scGlobalRegulate.getCid());
        }
        if (scGlobalRegulate.getSourceName() != null) {
            map.put("source_name",scGlobalRegulate.getSourceName());
        }
        if (scGlobalRegulate.getChildPrice() != null) {
            map.put("child_price",scGlobalRegulate.getChildPrice());
        }
        if (scGlobalRegulate.getAdultPrice() != null) {
            map.put("adult_price",scGlobalRegulate.getAdultPrice());
        }
        if (scGlobalRegulate.getUpdateTime() != null && !scGlobalRegulate.getUpdateTime().equals("")) {
            map.put("update_time",scGlobalRegulate.getUpdateTime());
        }
        if (scGlobalRegulate.getAddTime() != null && !scGlobalRegulate.getAddTime().equals("")) {
            map.put("add_time",scGlobalRegulate.getAddTime());
        }
        if (scGlobalRegulate.getStatus() != null) {
            map.put("status",scGlobalRegulate.getStatus());
        }
        if (scGlobalRegulate.getEditUser() != null && !scGlobalRegulate.getEditUser().equals("")) {
            map.put("edit_user",scGlobalRegulate.getEditUser());
        }
        if (scGlobalRegulate.getTimeStart() != null && !scGlobalRegulate.getTimeStart().equals("")) {
            map.put("time_start",scGlobalRegulate.getTimeStart());
        }
        if (scGlobalRegulate.getTimeEnd() != null && !scGlobalRegulate.getTimeEnd().equals("")) {
            map.put("time_end",scGlobalRegulate.getTimeEnd());
        }


        return map;

    }
    private Integer count(String where,Object[] objects) {
        String sql = "select count(*) from sc_global_regulate " + where;
        return jdbcTemplate.queryForObject(sql, Integer.class,objects);
    }
}
