package com.bjlt.spider.policy.dao.impl;


import com.bjlt.spider.entity.AirlineInfomation;
import com.bjlt.spider.entity.PolicyEntity;
import com.bjlt.spider.entity.SearchResponseEntity;
import com.bjlt.spider.entity.SourceEnum;
import com.bjlt.spider.policy.dao.PolicyEntityDao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.*;

import org.springframework.stereotype.Repository;

import java.util.*;
import java.util.stream.*;

/**
 * sc_policy
 */
@Repository
public class PolicyDaoImpl implements PolicyEntityDao {
    @Autowired
    private JdbcTemplate jdbcTemplate;

    @Override
    public List<PolicyEntity> listPagePolicyEntity(PolicyEntity scPolicy) {
        StringBuffer s = new StringBuffer();
        String select = "select id, ,cid,air_source_group_id,flight_number_limit, from_city, to_city, from_date_start, from_date_end, exclude_from_date_start, exclude_from_date_end, flight_number_limit_type, original_price, adjust_type, final_price, adjust_radio, add_or_subtract_money, score, low_price, up_price, edit_user, update_time, add_time from sc_policy,cabin_scope ";
        s.append(select);
        Map<String, Object> m = map(scPolicy);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        scPolicy.setTotal(count(where, m.values().toArray()));
        s.append(where);
        String limit = " limit " + scPolicy.getStart() + "," + scPolicy.getSize();
        s.append(limit);
        RowMapper<PolicyEntity> rowMapper = new BeanPropertyRowMapper<>(PolicyEntity.class);
        List<PolicyEntity> list = jdbcTemplate.query(s.toString(), rowMapper, m.values().toArray());

        return list;
    }


    @Override
    public void insertSelective(PolicyEntity scPolicy) {
        StringBuffer s = new StringBuffer();
        s.append("insert into sc_policy(");
        Map<String, Object> m = map(scPolicy);
        s.append(String.join(",", m.keySet()));
        s.append(") values (");
        List<String> wenhao = m.keySet().stream().map(t -> "?").collect(Collectors.toList());
        s.append(String.join(",", wenhao));
        s.append(")");
        System.out.println(s.toString());
        jdbcTemplate.update(s.toString(), m.values().toArray());
    }

    @Override
    public void updateByPrimaryKeySelective(PolicyEntity scPolicy) {
        StringBuffer s = new StringBuffer();
        s.append("update sc_policy set ");
        Map<String, Object> m = map(scPolicy);
        String update = m.keySet().stream().map(t -> t + "=?").collect(Collectors.joining(","));
        s.append(update);
        System.out.println(update);
        s.append(" where 	id=" + scPolicy.getId());
        jdbcTemplate.update(s.toString(), m.values().toArray());

    }


    @Override
    public List<PolicyEntity> listPolicyEntity(PolicyEntity scPolicy) {
        StringBuffer s = new StringBuffer();
        String select = "select id, cid,air_source_group_id,flight_number_limit, from_city, to_city, from_date_start, from_date_end, exclude_from_date_start, exclude_from_date_end, flight_number_limit_type, original_price, adjust_type, final_price, adjust_radio, add_or_subtract_money, score, low_price, up_price, edit_user, update_time, add_time ,cabin_scope from sc_policy ";
        s.append(select);
        Map<String, Object> m = map(scPolicy);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        s.append(where);
        RowMapper<PolicyEntity> rowMapper = new BeanPropertyRowMapper<>(PolicyEntity.class);
        List<PolicyEntity> list = jdbcTemplate.query(s.toString(), rowMapper, m.values().toArray());

        return list;
    }

    @Override
    public List<PolicyEntity> listPolicyEntityWithCondition(AirlineInfomation infomation, String cid) {
        StringBuffer s = new StringBuffer();
        String select = "select id,cabin_scope,cid, air_source_group_id, from_city, to_city, from_date_start, from_date_end, exclude_from_date_start, exclude_from_date_end, flight_number_limit_type, original_price, adjust_type, final_price, adjust_radio, add_or_subtract_money, score, low_price, up_price, edit_user, update_time, add_time,flight_number_limit ,cabin_scope from sc_policy ";
        s.append(select);

        String where = "where status = 1 " + beStringWithCondition(infomation,cid);
        s.append(where);
        RowMapper<PolicyEntity> rowMapper = new BeanPropertyRowMapper<>(PolicyEntity.class);
        List<PolicyEntity> list = jdbcTemplate.query(s.toString(), rowMapper);

        return list;
    }

    private String beStringWithCondition(AirlineInfomation infomation, String cid) {
        StringBuffer sb = new StringBuffer();

        if (infomation.getAirSourceName() != null) {
            sb.append("and air_source_group_id = " + infomation.getAirSourceName());
        }
        if (cid != null) {
            sb.append(" and cid ='" + cid + "'");
        }



        if (infomation.getFromDate() != null && !"".equals(infomation.getFromDate())) {
            sb.append(" and from_date_start <='" + infomation.getFromDate() + "'");
            sb.append(" and from_date_end >='" + infomation.getFromDate() + "'");

        }



        sb.append(" and (from_city = '" + infomation.getFormCity() + "' or from_city = '*')");

        sb.append(" and (to_city = '" + infomation.getToCity() + "' or to_city = '*')");

        return sb.toString();
    }

    @Override
    public void deletePolicyEntity(PolicyEntity scPolicy) {
        StringBuffer s = new StringBuffer();
        String select = "delete  from sc_policy ";
        Map<String, Object> m = new HashMap();
        s.append(select);
        String where = "where status = 1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        s.append(where);
        jdbcTemplate.update(s.toString(), m.values().toArray());

    }

    private static Map<String, Object> map(PolicyEntity scPolicy) {
        Map<String, Object> map = new HashMap();
        if (scPolicy.getId() != null) {
            map.put("id", scPolicy.getId());
        }
        if (scPolicy.getCid() != null) {
            map.put("cid", scPolicy.getCid());
        }
        if (scPolicy.getAirSourceGroupId() != null) {
            map.put("air_source_group_id", scPolicy.getAirSourceGroupId());
        }
        if (scPolicy.getFromCity() != null && !"".equals(scPolicy.getFromCity())) {
            map.put("from_city", scPolicy.getFromCity());
        }
        if (scPolicy.getToCity() != null && !"".equals(scPolicy.getToCity())) {
            map.put("to_city", scPolicy.getToCity());
        }
//        if (scPolicy.getFromDate() != null && !"".equals(scPolicy.getFromDate())) {
//            map.put("from_date", scPolicy.getFromDate());
//        }
//        if (scPolicy.getRetDate() != null && !"".equals(scPolicy.getRetDate())) {
//            map.put("ret_date", scPolicy.getRetDate());
//        }
//        if (scPolicy.getExcludeFromDate() != null && !"".equals(scPolicy.getExcludeFromDate())) {
//            map.put("exclude_from_date", scPolicy.getExcludeFromDate());
//        }
//        if (scPolicy.getExcludeRetDate() != null && !"".equals(scPolicy.getExcludeRetDate())) {
//            map.put("exclude_ret_date", scPolicy.getExcludeRetDate());
//        }
        if (scPolicy.getFlightNumberLimitType() != null) {
            map.put("flight_number_limit_type", scPolicy.getFlightNumberLimitType());
        }
        if (scPolicy.getOriginalPrice() != null) {
            map.put("original_price", scPolicy.getOriginalPrice());
        }
        if (scPolicy.getAdjustType() != null && !"".equals(scPolicy.getAdjustType())) {
            map.put("adjust_type", scPolicy.getAdjustType());
        }
        if (scPolicy.getFinalPrice() != null) {
            map.put("final_price", scPolicy.getFinalPrice());
        }
        if (scPolicy.getAdjustRadio() != null) {
            map.put("adjust_radio", scPolicy.getAdjustRadio());
        }
        if (scPolicy.getAddOrSubtractMoney() != null) {
            map.put("add_or_subtract_money", scPolicy.getAddOrSubtractMoney());
        }
        if (scPolicy.getScore() != null) {
            map.put("score", scPolicy.getScore());
        }
        if (scPolicy.getLowPrice() != null) {
            map.put("low_price", scPolicy.getLowPrice());
        }
        if (scPolicy.getUpPrice() != null) {
            map.put("up_price", scPolicy.getUpPrice());
        }
        if (scPolicy.getEditUser() != null && !"".equals(scPolicy.getEditUser())) {
            map.put("edit_user", scPolicy.getEditUser());
        }
        if (scPolicy.getUpdateTime() != null && !"".equals(scPolicy.getUpdateTime())) {
            map.put("update_time", scPolicy.getUpdateTime());
        }
        if (scPolicy.getAddTime() != null && !"".equals(scPolicy.getAddTime())) {
            map.put("add_time", scPolicy.getAddTime());
        }
        if (scPolicy.getCabinScope() != null && "".equals(scPolicy.getCabinScope())){
            map.put("cabin_scope",scPolicy.getCabinScope());
        }

        return map;

    }

    private Integer count(String where, Object[] objects) {
        String sql = "select count(*) from sc_policy " + where;
        return jdbcTemplate.queryForObject(sql, Integer.class, objects);
    }


}
