package com.bjlt.spider.qunaer.cotroller;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.bjlt.spider.common.PlatformCids;
import com.bjlt.spider.qunaer.entity.*;
import com.bjlt.spider.qunaer.service.QunaerService;
import com.bjlt.spider.utils.Encrypt;
import com.bjlt.spider.utils.LoadParam;
import com.bjlt.spider.utils.RestTemplateUtils;
import com.fasterxml.jackson.databind.ObjectMapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

@Controller
@RequestMapping(value = "/qunaer")
@Slf4j
public class QunaerOrderController {



    @Autowired
    private QunaerService qunaerService;

    private ObjectMapper objectMapper = new ObjectMapper();

    @PostMapping(value = "order", consumes = MediaType.TEXT_PLAIN_VALUE)
    @ResponseBody
    public String order(HttpServletRequest request) throws Exception {


        String param = LoadParam.read(request.getInputStream());

        String decrypt = Encrypt.decrypt(param, "b6iYXliLAjhbB3oc");

        JSONObject object = JSONObject.parseObject(decrypt);


        log.info("生单 JSON{}",object);

        String cid = object.getString("cid");

        String orderSource = object.getString("orderSource");

        String tripTpye = object.getString("tripType");

        String sessionId = object.getString("sessionId");

        String routingString = object.getJSONObject("routing").toJSONString();

        JSONArray passengers = object.getJSONArray("passengers");


        List<PassengersInfo> passengersInfos = new ArrayList<>();

         for (Object passenger : passengers) {
            PassengersInfo ps = objectMapper.readValue(passenger.toString(), PassengersInfo.class);

            passengersInfos.add(ps);
        }

        String contactString = object.getString("contact");

        ContactInfo contact = objectMapper.readValue(contactString, ContactInfo.class);


        QunarRoutings qunarRoutings = objectMapper.readValue(routingString, QunarRoutings.class);


        QunaerOrderParams params = new QunaerOrderParams();


        params.setContact(contact);

        params.setCid(cid);

        params.setTripType(tripTpye);

        params.setRouting(qunarRoutings);

        params.setSessionId(sessionId);

        params.setPassengers(passengersInfos.toArray(new PassengersInfo[]{}));


        params.setOrderSource(orderSource);


        QunaerOrderRespEntity order = qunaerService.order(params, PlatformCids.QUNA);

        String s = JSONObject.toJSONString(order);

        log.info("加密前{}", s);

        String encrypt = Encrypt.encrypt(s, "b6iYXliLAjhbB3oc");

        return encrypt;
    }


}
