package com.bjlt.spider.qunaer.cotroller;

import com.alibaba.fastjson.JSONObject;
import com.bjlt.spider.entity.OrOrdertb;
import com.bjlt.spider.entity.OrderStatus;
import com.bjlt.spider.orderInfo.service.OrOrdertbService;
import com.bjlt.spider.qunaer.entity.QunaerPayParams;
import com.bjlt.spider.qunaer.entity.QunaerPayRespEntity;
import com.bjlt.spider.qunaer.entity.QunarRoutings;
import com.bjlt.spider.qunaer.service.QunaerService;
import com.bjlt.spider.utils.Encrypt;
import com.bjlt.spider.utils.LoadParam;
import com.bjlt.spider.utils.RestTemplateUtils;
import com.fasterxml.jackson.databind.ObjectMapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.math.BigDecimal;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 14:21 2017/12/25
 */
@Controller
@RequestMapping(value = "/qunaer")
@Slf4j
public class QunaerPayController {


    @Autowired
    private OrOrdertbService orOrdertbService;

    private ObjectMapper objectMapper = new ObjectMapper();

    @PostMapping(value = "pay", consumes = MediaType.TEXT_PLAIN_VALUE)
    @ResponseBody
    public String pay(HttpServletRequest request) throws Exception {


        /**
         * "cid": "QUNA",
         "tripType": "1",
         "sessionId": "2018012011402315931149549",
         "orderNo": "2018012011402316231157915",
         "pnrCode": "u57rZg",
         */


        String param = LoadParam.read(request.getInputStream());

        String decrypt = Encrypt.decrypt(param, "b6iYXliLAjhbB3oc");

        JSONObject object = JSONObject.parseObject(decrypt);

        String cid = object.getString("cid");

        String orderNo = object.getString("orderNo");

        String tripTpye = object.getString("tripType");

        String sessionId = object.getString("sessionId");

        String pnrCode = object.getString("pnrCode");

        String routingString = object.getJSONObject("routing").toJSONString();

        QunarRoutings qunarRoutings = objectMapper.readValue(routingString, QunarRoutings.class);

//
//        QunaerPayParams payParams = new QunaerPayParams();
//
//        payParams.setTripType(tripTpye);
//
//        payParams.setSessionId(sessionId);
//
//        payParams.setQunarRoutings(qunarRoutings);
//
//        payParams.setPnrCode(pnrCode);
//
//        payParams.setCid(cid);
//
//        payParams.setOrderNo(orderNo);

       // return RestTemplateUtils.getPayResp(payParams, payUrl);


        //找到那个订单

        OrOrdertb orOrdertb = orOrdertbService.listOrOrdertb(OrOrdertb.builder().orderno(orderNo).pnrcode(pnrCode).build()).get(0);


        BigDecimal adultprice = orOrdertb.getAdultprice();


        qunarRoutings.setAdultPrice(adultprice);


        qunarRoutings.setAdultTax(orOrdertb.getChildprice());


        Integer childrencount = orOrdertb.getChildrencount();

        if (!childrencount.equals(0)) {
            qunarRoutings.setChildPrice(orOrdertb.getChildprice());
            qunarRoutings.setChildTax(orOrdertb.getAdulttax());
        } else {
            qunarRoutings.setChildPrice(new BigDecimal(0));
            qunarRoutings.setChildTax(new BigDecimal(0));
        }

        qunarRoutings.setAdultTaxType(0);

        qunarRoutings.setChildTaxType(0);

        qunarRoutings.setPriceType(0);

        qunarRoutings.setApplyType(0);

        qunarRoutings.setTicketTimeLimit(60);

        orOrdertb.setOrderstatus(OrderStatus.ORDER_PAY_OK.getStatus());


        orOrdertbService.updateByPrimaryKeySelective(orOrdertb);


        QunaerPayRespEntity entity = new QunaerPayRespEntity();


        entity.setMsg("支付成功");

        entity.setStatus(0);


        entity.setSessionId(sessionId);

        entity.setPnrCode(pnrCode);


        entity.setRouting(qunarRoutings);

        entity.setOrderNo(orderNo);


        String s = JSONObject.toJSONString(entity);


        String encrypt = Encrypt.encrypt(s, "b6iYXliLAjhbB3oc");


        return encrypt;
    }
}
