package com.bjlt.spider.qunaer.dao.impl;


import com.bjlt.spider.qunaer.dao.RefundRulesDao;
import com.bjlt.spider.qunaer.entity.QunaerRule;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * sc_refund_rules
 */
@Repository
public class RefundRulesDaoImpl implements RefundRulesDao {
    @Autowired
    private JdbcTemplate jdbcTemplate;


    @Override
    public List<QunaerRule> listPageRefundRules(QunaerRule qunaerRule) {
        StringBuffer s = new StringBuffer();
        String select = "select id, tag,source_group_id, has_refund, refund, part_refund, part_refund_price, has_endorse, endorse, part_endorse, part_endorse_price, endorsement, has_baggage, baggage, has_no_show, no_show_limit_time, penalty, special_no_show, other, edit_user, add_time, update_time from sc_refund_rules ";
        s.append(select);
        Map<String, Object> m = map(qunaerRule);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        qunaerRule.setTotal(count(where, m.values().toArray()));
        s.append(where);
        String limit = " limit " + qunaerRule.getStart() + "," + qunaerRule.getSize();
        s.append(limit);
        RowMapper<QunaerRule> rowMapper = new BeanPropertyRowMapper<QunaerRule>(QunaerRule.class);
        List<QunaerRule> list = jdbcTemplate.query(s.toString(), rowMapper, m.values().toArray());

        return list;
    }


    @Override
    public void insertSelective(QunaerRule qunaerRule) {
        StringBuffer s = new StringBuffer();
        s.append("insert into sc_refund_rules(");
        Map<String, Object> m = map(qunaerRule);
        s.append(String.join(",", m.keySet()));
        s.append(") values (");
        List<String> wenhao = m.keySet().stream().map(t -> "?").collect(Collectors.toList());
        s.append(String.join(",", wenhao));
        s.append(")");
        System.out.println(s.toString());
        jdbcTemplate.update(s.toString(), m.values().toArray());
    }


    @Override
    public void deleteRefundRules(QunaerRule qunaerRule) {
        StringBuffer s = new StringBuffer();
		String select = "delete  from sc_refund_rules ";
		Map<String, Object> m = new HashMap();
		s.append(select);
		String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
		s.append(where);
		jdbcTemplate.update(s.toString(), m.values().toArray());
    }


    @Override
    public void updateByPrimaryKeySelective(QunaerRule qunaerRule) {
        StringBuffer s = new StringBuffer();
        s.append("update sc_refund_rules set ");
        Map<String, Object> m = map(qunaerRule);
        String update = m.keySet().stream().map(t -> t + "=?").collect(Collectors.joining(","));
        s.append(update);
        System.out.println(update);
        s.append(" where 	id=" + qunaerRule.getId());
        jdbcTemplate.update(s.toString(), m.values().toArray());
    }


    @Override
    public List<QunaerRule> listRefundRules(QunaerRule qunaerRule) {
        StringBuffer s = new StringBuffer();
        String select = "select id, tag, source_group_id, has_refund, refund, part_refund, part_refund_price, has_endorse, endorse, part_endorse, part_endorse_price, endorsement, has_baggage, baggage, has_no_show, no_show_limit_time, penalty, special_no_show, other, edit_user, add_time, update_time from sc_refund_qunaer_rules ";
        s.append(select);
        Map<String, Object> m = map(qunaerRule);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        s.append(where);
        RowMapper<QunaerRule> rowMapper = new BeanPropertyRowMapper<QunaerRule>(QunaerRule.class);
        List<QunaerRule> list = jdbcTemplate.query(s.toString(), rowMapper, m.values().toArray());

        return list;
    }

//
//	@Override
//	public List<QunaerRule> listqunaerRule(QunaerRule qunaerRule) {

//	}
//	@Override
//	public void deletequnaerRule(QunaerRule qunaerRule) {
//
//
//	}

    private static Map<String, Object> map(QunaerRule qunaerRule) {
        Map<String, Object> map = new HashMap();
        if (qunaerRule.getId() != null) {
            map.put("id", qunaerRule.getId());
        }
        if (qunaerRule.getSourceGroupId() != null) {
            map.put("source_group_id", qunaerRule.getSourceGroupId());
        }
        if (qunaerRule.getHasRefund() != null) {
            map.put("has_refund", qunaerRule.getHasRefund());
        }
        if (qunaerRule.getRefund() != null && !qunaerRule.getRefund().equals("")) {
            map.put("refund", qunaerRule.getRefund());
        }
        if (qunaerRule.getPartRefund() != null) {
            map.put("part_refund", qunaerRule.getPartRefund());
        }
        if (qunaerRule.getPartRefundPrice() != null && !qunaerRule.getPartRefundPrice().equals("")) {
            map.put("part_refund_price", qunaerRule.getPartRefundPrice());
        }
        if (qunaerRule.getHasEndorse() != null) {
            map.put("has_endorse", qunaerRule.getHasEndorse());
        }
        if (qunaerRule.getEndorse() != null && !qunaerRule.getEndorse().equals("")) {
            map.put("endorse", qunaerRule.getEndorse());
        }
        if (qunaerRule.getPartEndorse() != null) {
            map.put("part_endorse", qunaerRule.getPartEndorse());
        }
        if (qunaerRule.getPartEndorsePrice() != null) {
            map.put("part_endorse_price", qunaerRule.getPartEndorsePrice());
        }
        if (qunaerRule.getEndorsement() != null) {
            map.put("endorsement", qunaerRule.getEndorsement());
        }
        if (qunaerRule.getHasBaggage() != null) {
            map.put("has_baggage", qunaerRule.getHasBaggage());
        }
        if (qunaerRule.getBaggage() != null && !qunaerRule.getBaggage().equals("")) {
            map.put("baggage", qunaerRule.getBaggage());
        }
        if (qunaerRule.getHasNoShow() != null) {
            map.put("has_no_show", qunaerRule.getHasNoShow());
        }
        if (qunaerRule.getNoShowLimitTime() != null) {
            map.put("no_show_limit_time", qunaerRule.getNoShowLimitTime());
        }
        if (qunaerRule.getPenalty() != null) {
            map.put("penalty", qunaerRule.getPenalty());
        }
        if (qunaerRule.getSpecialNoShow() != null) {
            map.put("special_no_show", qunaerRule.getSpecialNoShow());
        }
        if (qunaerRule.getOther() != null && !qunaerRule.getOther().equals("")) {
            map.put("other", qunaerRule.getOther());
        }
        if (qunaerRule.getEditUser() != null && !qunaerRule.getEditUser().equals("")) {
            map.put("edit_user", qunaerRule.getEditUser());
        }
        if (qunaerRule.getAddTime() != null && !qunaerRule.getAddTime().equals("")) {
            map.put("add_time", qunaerRule.getAddTime());
        }
        if (qunaerRule.getUpdateTime() != null && !qunaerRule.getUpdateTime().equals("")) {
            map.put("update_time", qunaerRule.getUpdateTime());
        }
        if (qunaerRule.getTag() != null && !qunaerRule.getTag().equals("")) {
            map.put("tag", qunaerRule.getTag());
        }

        return map;

    }

    private Integer count(String where, Object[] objects) {
        String sql = "select count(*) from sc_refund_rules " + where;
        return jdbcTemplate.queryForObject(sql, Integer.class, objects);
    }


}
