package com.bjlt.spider.qunaer.entity;

import com.bjlt.spider.entity.RuleEntity;
import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.io.Serializable;
import java.math.BigDecimal;

@NoArgsConstructor
public class QunaerOrderRespEntity implements Serializable {


    public static final Integer SUCCESSCODE = 0;
    @Getter
    @Setter
    public QunarRoutings routing;

    @Getter
    @Setter
    public RuleEntity rule;


    @Getter
    @Setter
    public String sessionId;


    @Getter
    @Setter
    public Integer maxSeats;


    @Getter
    @Setter
    public String  currency;


    @Getter
    @Setter
    public String  orderNo;

    @Getter
    @Setter
    public String  pnrCode;



    @Getter
    @Setter
    @JsonIgnore
    public BigDecimal fee;



    @Getter
    @Setter
    public int status;
    @Getter
    @Setter
    public String msg;


    public QunaerOrderRespEntity(int status, String msg) {
        this.status = status;
        this.msg = msg;
    }

    public QunaerOrderRespEntity(QunarRoutings routings, int status, String msg) {
        this.routing = routings;
        this.status = status;
        this.msg = msg;
    }

    public QunaerOrderRespEntity(QunarRoutings routings, int status) {
        this.routing = routings;
        this.status = status;
    }

    public static QunaerOrderRespEntity success(QunarRoutings routings) {
        return new QunaerOrderRespEntity(routings, SUCCESSCODE);
    }

    public static QunaerOrderRespEntity success(QunarRoutings routings, String msg) {
        return new QunaerOrderRespEntity(routings, SUCCESSCODE, msg);
    }

    public static QunaerOrderRespEntity error(String msg) {
        return new QunaerOrderRespEntity(1, msg);
    }

    @Override
    public String toString() {
        return "QunaerOrderRespEntity{" +
                "routings=" + routing +
                ", status=" + status +
                ", msg='" + msg + '\'' +
                '}';
    }


}
