package com.bjlt.spider.qunaer.entity;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 14:59 2017/10/25
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class QunaerSearchParams implements Serializable {
    private static final long serialVersionUID = 4391896453766822019L;

    /**
     * 接口身份标识用户名（渠道唯一标识）
     */
    private String cid;
    /**
     * 行程类型，
     1：单程；
     2：往返；
     3：多程；
     */
    private String tripType;
    /**
     * 没有该字段时，默认乘客类型为成人，乘机总人数为1 （即：1个成人）
     *  有该字段时，代表乘客类型为成人的乘机总人数
     */
    private Integer adultNum;
    /**
     * 没有该字段时，默认为0个儿童
     * 有该字段时，代表乘客类型为儿童的乘机总人数
     */
    private Integer childNum;
    /**
     * 出发地IATA三字码代码
     */
    private String fromCity;

    /**
     * 目的地城市 、到达城市IATA 三字码代码
     */
    private String toCity;
    /**
     * 去程，格式为 YYYYMMDD，YYYYMMDD
     */
    private String fromDate;
    /**
     * 回程日期，格式为 YYYYMMDD（留空表示单程）
     */
    private String retDate;

}
