package com.bjlt.spider.qunaer.entity;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.io.Serializable;
import java.util.List;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 15:13 2017/10/25
 */
@NoArgsConstructor
public class QunaerSearchRespEntity implements Serializable{



    private static final long serialVersionUID = -6827430582941645032L;


    public static final Integer SUCCESSCODE = 0;
    @Getter
    @Setter
    public List<QunarRoutings> routings;
    @Getter
    @Setter
    public int status;
    @Getter
    @Setter
    public String msg;

    public QunaerSearchRespEntity(int status, String msg) {
        this.status = status;
        this.msg = msg;
    }

    public QunaerSearchRespEntity(List<QunarRoutings> routings, int status, String msg) {
        this.routings = routings;
        this.status = status;
        this.msg = msg;
    }

    public QunaerSearchRespEntity(List<QunarRoutings> routings, int status) {
        this.routings = routings;
        this.status = status;
    }

    public static QunaerSearchRespEntity success(List<QunarRoutings> routings) {
        return new QunaerSearchRespEntity(routings, SUCCESSCODE);
    }

    public static QunaerSearchRespEntity success(List<QunarRoutings> routings, String msg) {
        return new QunaerSearchRespEntity(routings, SUCCESSCODE, msg);
    }

    public static QunaerSearchRespEntity error(String msg) {
        return new QunaerSearchRespEntity(1, msg);
    }

    @Override
    public String toString() {
        return "QunaerSearchRespEntity{" +
                "routings=" + routings +
                ", status=" + status +
                ", msg='" + msg + '\'' +
                '}';
    }
}
