package com.bjlt.spider.qunaer.entity;

import com.bjlt.spider.entity.RuleEntity;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.io.Serializable;

@NoArgsConstructor
public class QunaerVerifyRespEntity implements Serializable{
    private static final long serialVersionUID = 401589403053924958L;


    public static final Integer SUCCESSCODE = 0;
    @Getter
    @Setter
    public QunarRoutings routing;

    @Getter
    @Setter
    public RuleEntity rule;


    @Getter
    @Setter
    public String sessionId;


    @Getter
    @Setter
    public Integer maxSeats;

    @Getter
    @Setter
    public int status;
    @Getter
    @Setter
    public String msg;


    public QunaerVerifyRespEntity(int status, String msg) {
        this.status = status;
        this.msg = msg;
    }

    public QunaerVerifyRespEntity(QunarRoutings routing, int status, String msg) {
        this.routing = routing;
        this.status = status;
        this.msg = msg;
    }

    public QunaerVerifyRespEntity(QunarRoutings routing, int status) {
        this.routing = routing;
        this.status = status;
    }

    public static QunaerVerifyRespEntity success(QunarRoutings routing) {
        return new QunaerVerifyRespEntity(routing, SUCCESSCODE);
    }

    public static QunaerVerifyRespEntity success(QunarRoutings routing, String msg) {
        return new QunaerVerifyRespEntity(routing, SUCCESSCODE, msg);
    }

    public static QunaerVerifyRespEntity error(String msg) {
        return new QunaerVerifyRespEntity(1, msg);
    }

    @Override
    public String toString() {
        return "QunaerSearchRespEntity{" +
                "routing=" + routing +
                ", status=" + status +
                ", msg='" + msg + '\'' +
                '}';
    }

}
