package com.bjlt.spider.qunaer.entity;

import com.bjlt.spider.entity.RouteInfoEntity;
import com.bjlt.spider.entity.RuleEntity;
import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.List;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 15:22 2017/10/25
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class QunarRoutings  implements   Serializable {
    private static final long serialVersionUID = -1879644376543842614L;

    /**
     * UUID
     */
    @JsonIgnore
    private String uuid;

    /**
     * policyID
     */
    private String policyID;

    /**
     * 辅助
     */
    @JsonIgnore
    private PriceMap  priceMap;

    /**
     * 廉航套餐类型,tag为0表示非套餐,大于0表示为套餐类型
     */
    private Integer tag;

    @JsonIgnore
    private Integer retTag;


    private Integer maxSeats;


    /**
     * 一些附加的信息
     */
    private String data;

    /**
     * 币种
     */
    private String curreny;

    /**
     * 成人总价格
     */
    private BigDecimal adultPrice;


    /**
     * 成人税费
     */
    private BigDecimal adultTax;

    /**
     * 儿童总价格
     */
    private BigDecimal childPrice;

    /**
     * 儿童税费
     */
    private BigDecimal childTax;

    /**
     * 乘客国籍 ： 0- 全部，1 -适用 ，2 - 不适用
     */
    private Integer nationalityType;

    /**
     * 乘客国籍，可以为空，若输入则为国家二字代码，多个用，分割
     */
    private String nationality;

    /**
     * 适用乘客年级，可以为空，
     */
    private String suitAge;

    /**
     * 报价类型 ： 0 - 普通价，1 - 留学生价
     */
    private Integer priceType;

    /**
     * 报价类型:   0 - 预定价 ，1 - 申请价 ， 2 - 预约
     */
    private Integer applyType;

    /**
     * 成人税费类型
     */
    private Integer adultTaxType;


    /**
     * 儿童税费类型
     */
    private Integer childTaxType;

    /**
     * 出票速度: [1-10080](以分钟为单位)
     */
    private Integer ticketTimeLimit;

    /**
     * 报销凭证  0 - 行程单 ， 1 - 旅行发票
     */
    private Integer ticketInvoiceType;



    private RuleEntity rule;


    /**
     * 去程信息
     */
    private List<RouteInfoEntity> fromSegments;


    /**
     * 回程航段
     */
    private List<RouteInfoEntity>  retSegments;



    /**
     *
     */
    @JsonIgnore
    private String fromCity;

    /**
     *
     */
    @JsonIgnore
    private String toCity;

    /**
     *
     */
    @JsonIgnore
    private String fromDate;

    /**
     *
     */
    @JsonIgnore
    private String retDate;

    /**
     *
     */
    @JsonIgnore
    private String tripType;


}
