package com.bjlt.spider.taobao.controller;

import com.alibaba.fastjson.JSONObject;
import com.bjlt.spider.taobao.entity.TaobaoPayRespEntity;
import com.bjlt.spider.taobao.entity.TaobaoPayRestParam;
import com.bjlt.spider.taobao.entity.TaobaoRouting;
import com.bjlt.spider.taobao.service.TaobaoPayService;
import com.bjlt.spider.utils.Encrypt;
import com.bjlt.spider.utils.LoadParam;
import com.fasterxml.jackson.databind.ObjectMapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 20:39 2018/1/16
 */
@Controller
@RequestMapping(value = "/taobao")
@Slf4j
public class PayController {


    @Autowired
    private TaobaoPayService taobaoPayService;

    @ResponseBody
    @PostMapping(value = "pay",consumes = MediaType.TEXT_PLAIN_VALUE)
    public String pay(HttpServletRequest request) throws Exception{

        log.info("------TAOBAO  支付请求---------");


        String param = LoadParam.read(request.getInputStream());

        String decrypt = Encrypt.decrypt(param, "Ir9ym6Bc8lCrrNvC");

        JSONObject object = JSONObject.parseObject(decrypt);

        String cid = object.getString("cid");
        String tripType = object.getString("tripType");

        String sessionId = object.getString("sessionId");

        String orderNo = object.getString("orderNo");

        String pnrCode = object.getString("pnrCode");

        String routingString = object.getJSONObject("routing").toJSONString();

        ObjectMapper objectMapper = new ObjectMapper();

        TaobaoRouting taobaoRouting = objectMapper.readValue(routingString, TaobaoRouting.class);


        TaobaoPayRestParam payRestParam = new TaobaoPayRestParam();

        payRestParam.setCid(cid);

        payRestParam.setOrderNo(orderNo);

        payRestParam.setPnrCode(pnrCode);

        payRestParam.setRouting(taobaoRouting);

        payRestParam.setSessionId(sessionId);

        payRestParam.setTripType(tripType);


        TaobaoPayRespEntity pay = taobaoPayService.pay(payRestParam);
        String s = JSONObject.toJSONString(pay);


        String encrypt = Encrypt.encrypt(s, "Ir9ym6Bc8lCrrNvC");
        return encrypt;

    }
}
