package com.bjlt.spider.taobao.controller;

import com.alibaba.fastjson.JSONObject;
import com.bjlt.spider.entity.PlatformSourceVo;
import com.bjlt.spider.qunaer.entity.QunaerSearchParams;
import com.bjlt.spider.qunaer.entity.QunaerSearchRespEntity;
import com.bjlt.spider.taobao.entity.TaobaoSearchRespEntity;
import com.bjlt.spider.taobao.service.TaobaoSearchService;
import com.bjlt.spider.util.RedisPrefix;
import com.bjlt.spider.utils.LoadParam;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 14:53 2018/1/15
 */
@RestController
@RequestMapping(value = "/taobao")
@Slf4j
public class SearchController {


    @Autowired
    private RedisTemplate redisTemplate;


    @Autowired
    private TaobaoSearchService searchService;

    @PostMapping(value = "search",consumes = MediaType.TEXT_PLAIN_VALUE)
    public TaobaoSearchRespEntity search(HttpServletRequest request) throws Exception {

        String param = LoadParam.read(request.getInputStream());
        JSONObject object = JSONObject.parseObject(param);
        String cid = object.getString("cid");
        String  tripType = object.getString("tripType");
        String fromCity = object.getString("fromCity");
        String toCity = object.getString("toCity");
        String fromDate = object.getString("fromDate");
        String retDate = object.getString("retDate");


        if (StringUtils.isBlank(fromCity) || StringUtils.isBlank(fromDate) || StringUtils.isBlank(toCity)
                || StringUtils.isBlank(cid)) {
            return new TaobaoSearchRespEntity(99,"fail",null);
        }

        Integer passengerCount = new Integer(0);


        //拿到默认人数
        //TODO 大 BUG
        PlatformSourceVo vo = (PlatformSourceVo) redisTemplate.opsForValue().get(RedisPrefix.AIRSOURCEPLATFORM.getPrefix()+cid+"1");

        Integer defultCount = null;
        if (vo != null){
            defultCount = vo.getPassengerCount();
        }else {
            defultCount = 3;
        }

        QunaerSearchParams params = QunaerSearchParams.builder()
                .adultNum(defultCount)
                .childNum(null)
                .cid(cid)
                .fromCity(fromCity)
                .retDate(retDate)
                .tripType(tripType)
                .fromDate(fromDate)
                .toCity(toCity)
                .build();

        log.info("收到来自 TAOBAO 的搜索请求{}",params.toString());
        return searchService.search(params);
    }



}
