package com.bjlt.spider.taobao.entity;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 16:59 2018/1/15
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class TaobaoBaggage implements Serializable{

    private static final long serialVersionUID = 6160999301749788299L;
    /**
     * 行李总件数
     */
    private int pc;

    /**
     * 行李重量，当 allWeight 为是的时候行李重量描述所 有件数的总重量，单位固定为:KG 当行李总件数不为 0 时必须传。
     */
    private int weight;

    /**
     * 是否所有行李重量 当行李总件数不为 0 时必须传。
     */
    private boolean isAllWeight;

    /**
     * 单件行李长度限制，单位厘米。
     */
    private int length;

    /**
     * 单件行李宽度限制，单位厘米。
     */
    private int width;

    /**
     * 单件行李高度限制，单位厘米。
     */
    private int height;
}
