package com.bjlt.spider.taobao.entity;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 15:53 2018/1/15
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class TaobaoSearchEntity implements Serializable {

    private static final long serialVersionUID = 1956174364096636829L;
    /**
     * 接口身份标识用户名(渠道唯一标识)
     */
    private String cid;

    /**
     * 1:单程; 2:往返; 5: 多程; 多程最多支持三程六段 (多程功能暂未开放)
     */
    private int tripType;
    /**
     * 出发地 IATA 三字码代码;
     */
    private String fromCity;


    /**
     * 目的地城市 、到达城市 IATA 三字码代码 ;多程为空
     */
    private String toCity;


    /**
     * 去程日期，格式为 YYYYMMDD
     */
    private String fromDate;

    /**
     * 回程日期，格式为 YYYYMMDD
     */
    private String retDate;


}
