package com.bjlt.spider.taobao.entity;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 20:55 2018/1/15
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class TaobaoVerifyRespEntity {
    /**
     * int
     0,成功;
     999: 其他失败原因 ; 1，请求参数错误;
     2，程序异常;
     3，舱位数不足;
     4. 查无价格;
     5. 无法获取税费;
     6. 退改签异常，含获取不到或者异常;
     */
    private int status;
    /**
     * 提示信息，长度小于 64
     */
    private String msg;

    /**
     * 会话标识:标记服务接口调用的唯一标识，相应 的调用结果中会原值返回。数字或字母，长度小 于 20 个字符
     */
    private String sessionId;

    /**
     * 可预订的座位数，最大为 9
     */
    private int maxSeats;

    /**
     * 报价信息，参考搜索返回结果中的 Routing Elements。(verify 报价比 search 报价过高会导致验价失
     败，价差较小时以 search 报价为准，verify 报 价比 search 报价低较多时以 verify 价格为准。 具体的差异上下限请咨询运营。)
     */
    private TaobaoRouting routing;

    /**
     * 退改签信息，参考搜索接口返回结果中的 Rule Element
     */
    private TaobaoRule rule;
}
