package com.bjlt.spider.taobao.service;

import com.bjlt.spider.common.DataEntity;
import com.bjlt.spider.common.MethedNames;
import com.bjlt.spider.common.PlatformCids;
import com.bjlt.spider.entity.SearchRequestAfterOta;
import com.bjlt.spider.qunaer.entity.PriceMap;
import com.bjlt.spider.qunaer.entity.QunarRoutings;
import com.bjlt.spider.utils.CreateDataUtils;
import com.bjlt.spider.utils.OtaConfigGenerateKey;
import com.google.common.collect.Maps;

import java.math.BigDecimal;
import java.util.Map;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 16:46 2018/1/16
 */
public class BaseService {
    public static Map<String, Object> getRet(String data, QunarRoutings routings, String tripType, Integer childNum, Integer adultNum) {
        DataEntity dataEntity = CreateDataUtils.getinfo(data);


        String fromDate = dataEntity.getFromDate();
        String retDate = dataEntity.getRetDate();
        String fromCity = dataEntity.getFromCity();
        String toCity = dataEntity.getToCity();

        String pid = dataEntity.getPolicyId();
        PriceMap priceMap = dataEntity.getPriceMap();

        String sourceId = dataEntity.getSourceId();

        SearchRequestAfterOta searchRequestAfterOta = new SearchRequestAfterOta();


        searchRequestAfterOta.setChildNum(0);

        routings.getFromSegments().stream().forEach(t -> t.setCabinClass(null));

        if (tripType.equals("2")) {
            routings.getRetSegments().stream().forEach(t -> t.setCabinClass(null));
            routings.setRetDate(retDate);
            searchRequestAfterOta.setRetDate(retDate.replace("-", ""));
        }

        routings.setFromCity(fromCity);

        routings.setToCity(toCity);

        routings.setFromDate(fromDate);


        routings.setPriceMap(priceMap);

        routings.setTripType(tripType);

        searchRequestAfterOta.setCache(false);

        searchRequestAfterOta.setCid(PlatformCids.TAOBAO);

        searchRequestAfterOta.setAdultNum(adultNum);

        searchRequestAfterOta.setFromCity(fromCity);

        searchRequestAfterOta.setToCity(toCity);

        searchRequestAfterOta.setSourceId(sourceId);

        searchRequestAfterOta.setTripType(tripType);

        searchRequestAfterOta.setFromDate(fromDate.replace("-", ""));

        searchRequestAfterOta.setMethodName(MethedNames.verify);
        String uuid = "";
        if (tripType.equals("1")) {
            uuid = OtaConfigGenerateKey.fromKey(searchRequestAfterOta);
        } else {
            uuid = OtaConfigGenerateKey.allKey(searchRequestAfterOta);
        }

        searchRequestAfterOta.setUuid(uuid);

        Map<String, Object> ret = Maps.newHashMap();

        ret.put("otaConfig", searchRequestAfterOta);

        ret.put("routings", routings);

        ret.put("pid", pid);

//
        return ret;

    }
}
