package com.bjlt.spider.taobao.service.impl;

import com.bjlt.spider.common.DataEntity;
import com.bjlt.spider.entity.OrOrdertb;
import com.bjlt.spider.entity.OrderStatus;
import com.bjlt.spider.orderInfo.service.OrOrdertbService;
import com.bjlt.spider.qunaer.entity.PriceMap;
import com.bjlt.spider.taobao.entity.TaobaoPayRespEntity;
import com.bjlt.spider.taobao.entity.TaobaoPayRestParam;
import com.bjlt.spider.taobao.entity.TaobaoRouting;
import com.bjlt.spider.taobao.service.TaobaoPayService;
import com.bjlt.spider.utils.CreateDataUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 10:00 2018/1/17
 */
@Service
public class TaobaoPayServiceImpl implements TaobaoPayService {


    @Autowired
    private OrOrdertbService orOrdertbService;


    @Override
    public TaobaoPayRespEntity pay(TaobaoPayRestParam payRestParam) {


        TaobaoPayRespEntity payRespEntity = new TaobaoPayRespEntity();

        //找到那个订单

        OrOrdertb orOrdertb = orOrdertbService.listOrOrdertb(OrOrdertb.builder().orderno(payRestParam.getOrderNo()).build()).get(0);


        orOrdertb.setOrderstatus(OrderStatus.ORDER_PAY_OK.getStatus());
        TaobaoRouting routing = payRestParam.getRouting();

        String data = routing.getData();

        DataEntity entity = CreateDataUtils.getinfo(data);

        PriceMap priceMap = entity.getPriceMap();

        priceMap.getAdultPrice();

        routing.setAdultPrice(priceMap.getAdultPrice().intValue());

        routing.setAdultTax(priceMap.getAdultTax().intValue());

        routing.setChildTax(priceMap.getChildTax().intValue());

        routing.setChildPrice(priceMap.getChildPrice().intValue());

        orOrdertbService.updateByPrimaryKeySelective(orOrdertb);


        payRespEntity.setMsg("支付成功");

        payRespEntity.setStatus(0);


        payRespEntity.setSessionId(payRestParam.getSessionId());

        payRespEntity.setPnrCode(payRestParam.getPnrCode());


        payRespEntity.setTicketingGds("AK");

        payRespEntity.setRouting(payRestParam.getRouting());

        payRespEntity.setOrderNo(payRestParam.getOrderNo());

        return payRespEntity;
    }
}
