package com.bjlt.spider.utils;

import com.bjlt.spider.entity.RouteInfoEntity;
import com.bjlt.spider.hangbanguanjia.entity.Flight;
import com.bjlt.spider.hangbanguanjia.entity.MyFlight;
import com.bjlt.spider.qunaer.entity.QunarRoutings;

import java.io.*;
import java.util.ArrayList;
import java.util.List;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 11:38 2017/12/21
 */
public class CompareUtils {

    //只比较航班
    public static boolean compareFlight(MyFlight myFlight, List<MyFlight> myFlightList) throws CloneNotSupportedException, IOException, ClassNotFoundException {


        //List<MyFlight> myFlightList1 = deepCopy(myFlightList);


        //myFlightList1.stream().forEach(t->t.getFlights().stream().forEach(s->s.setUuid(null)));

        long count = myFlightList.stream().map(t -> t.getFlights()).filter(s -> s.equals(myFlight.getFlights())).count();

        if (count == 0) {
            return false;
        } else {
            return true;
        }
    }



    public static List<RouteInfoEntity> getEntity(List<QunarRoutings> qunarRoutingsList, Flight flight) {
        List<RouteInfoEntity> entityList = new ArrayList<>();
        for (QunarRoutings routings : qunarRoutingsList) {
            List<RouteInfoEntity> fromSegments = routings.getFromSegments();
            for (RouteInfoEntity fromSegment : fromSegments) {
                if (fromSegment.getCarrier().equals(flight.getFn().substring(0,2))
                    && fromSegment.getArrTime().equals(flight.getAt())
                    && fromSegment.getDepTime().equals(flight.getDt())
                    && fromSegment.getArrAirport().equals(flight.getDst())
                    && fromSegment.getDepAirport().equals(flight.getOrg())
                    && fromSegment.getFlightNumber().equals(flight.getFn())
                    && fromSegment.getAircraftCode().equals(flight.getAircraftCode()))
                        {
                    entityList.add(fromSegment);
                }
            }
            List<RouteInfoEntity> retSegments = routings.getRetSegments();
            for (RouteInfoEntity retSegment : retSegments) {
                if (retSegment.getCarrier().equals(flight.getFn().substring(0,2))
                        && retSegment.getArrTime().equals(flight.getAt())
                        && retSegment.getDepTime().equals(flight.getDt())
                        && retSegment.getArrAirport().equals(flight.getDst())
                        && retSegment.getDepAirport().equals(flight.getOrg())
                        && retSegment.getFlightNumber().equals(flight.getFn())
                        && retSegment.getAircraftCode().equals(flight.getAircraftCode())){
                    entityList.add(retSegment);
                }
            }
        }
        return entityList;

    }


    public static <T> List<T> deepCopy(List<T> src) throws IOException, ClassNotFoundException {
        ByteArrayOutputStream byteOut = new ByteArrayOutputStream();
        ObjectOutputStream out = new ObjectOutputStream(byteOut);
        out.writeObject(src);

        ByteArrayInputStream byteIn = new ByteArrayInputStream(byteOut.toByteArray());
        ObjectInputStream in = new ObjectInputStream(byteIn);
        @SuppressWarnings("unchecked")
        List<T> dest = (List<T>) in.readObject();
        return dest;
    }
}
