package com.bjlt.spider.utils;

import com.alibaba.fastjson.JSONObject;
import com.bjlt.spider.common.DataEntity;
import com.bjlt.spider.entity.AirlineInfomation;
import com.bjlt.spider.entity.AirlinePriceInfo;
import com.bjlt.spider.qunaer.entity.PriceMap;
import com.bjlt.spider.qunaer.entity.QunarRoutings;
import com.fasterxml.jackson.databind.ObjectMapper;

import java.io.UnsupportedEncodingException;
import java.math.BigDecimal;
import java.util.Base64;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 16:02 2017/12/26
 */
public class CreateDataUtils {

    final static Base64.Decoder decoder = Base64.getDecoder();
    final static Base64.Encoder encoder = Base64.getEncoder();
    final static ObjectMapper mapper = new ObjectMapper();

    public static String getData(AirlineInfomation airlineInfomation, AirlinePriceInfo fromAirlinePriceInfo, AirlinePriceInfo retAirlinePriceInfo, String pid,Integer fromTag,Integer retTag,Integer maxSeats) {
        String data = "";
        String fromCity = airlineInfomation.getFormCity();
        String toCity = airlineInfomation.getToCity();
        String fromDate = airlineInfomation.getFromDate();
        String retDate = airlineInfomation.getRetDate() == null ? "" : airlineInfomation.getRetDate();


        // List<AirlinePriceInfo> airlinePriceInfos = airlineInfomation.getAirlinePriceInfos();


//        for (AirlinePriceInfo airlinePriceInfo : airlinePriceInfos) {
        PriceMap priceMap = new PriceMap();

        if (retAirlinePriceInfo == null) {


            priceMap.setCabin(fromAirlinePriceInfo.getCabin());

            priceMap.setAdultPrice(fromAirlinePriceInfo.getAdultPrice());

            priceMap.setAdultTax(fromAirlinePriceInfo.getAdultTax());

            priceMap.setChildPrice(fromAirlinePriceInfo.getChildPrice());

            priceMap.setChildTax(fromAirlinePriceInfo.getChildTax());


        } else {


            priceMap.setCabin(fromAirlinePriceInfo.getCabin() + "&" + retAirlinePriceInfo.getCabin());

            priceMap.setAdultPrice(fromAirlinePriceInfo.getAdultPrice().add(retAirlinePriceInfo.getAdultPrice()));

            priceMap.setAdultTax(fromAirlinePriceInfo.getAdultTax().add(retAirlinePriceInfo.getAdultTax()));

            priceMap.setChildPrice(fromAirlinePriceInfo.getChildPrice().add(retAirlinePriceInfo.getChildPrice()));

            priceMap.setChildTax(fromAirlinePriceInfo.getChildTax().add(retAirlinePriceInfo.getChildTax()));
            priceMap.setRetTag(retTag);
        }
        priceMap.setFromTag(fromTag);
        priceMap.setMaxSeats(maxSeats);

        //}


       // String s = JSONObject.toJSONString(priceMap);

        DataEntity dataEntity = DataEntity.builder()

                .fromCity(fromCity)
                .toCity(toCity)
                .fromDate(fromDate)
                .retDate(retDate)
                .priceMap(priceMap)
                .policyId(pid)
                .sourceId(airlineInfomation.getAirSourceName())
                .build();


        try {
            String jsonString = JSONObject.toJSONString(dataEntity);


            data = encoder.encodeToString(jsonString.getBytes("Utf-8"));
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        return data;
    }


    public static String getDataInHbgj(QunarRoutings qunarRoutings) {
        String data = "";
        String fromCity = qunarRoutings.getFromCity();
        String toCity = qunarRoutings.getToCity();
        String fromDate = qunarRoutings.getFromDate();
        String toDate = qunarRoutings.getRetDate() == null ? "" : qunarRoutings.getRetDate();
        try {
            data = encoder.encodeToString((fromCity + "*" + toCity + "*" + fromDate + "*" + toDate).getBytes("Utf-8"));
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        return data;
    }


    public static DataEntity getinfo(String data) {


        DataEntity dataEntity = null;
        try {
            String info = new String(decoder.decode(data), "UTF-8");
            dataEntity = mapper.readValue(info, DataEntity.class);

        } catch (Exception e) {
            e.printStackTrace();
        }

        return dataEntity;
    }

    public static void main(String[] args) {
        DataEntity entity = getinfo("eyJmcm9tQ2l0eSI6IlNaWCIsImZyb21EYXRlIjoiMjAxOC0wMy0yMSIsInBvbGljeUlkIjoibnVsbCIsInByaWNlTWFwIjp7ImFkdWx0UHJpY2UiOjUyMSwiYWR1bHRUYXgiOjU4LCJjYWJpbiI6IkVDIiwiY2hpbGRQcmljZSI6NjIxLCJjaGlsZFRheCI6NTgsImZyb21UYWciOjAsIm1heFNlYXRzIjo1fSwicmV0RGF0ZSI6IiIsInRvQ2l0eSI6IkRNSyJ9");

        System.out.println(entity);
    }
}


