package com.bjlt.spider.utils;

import com.bjlt.spider.entity.ScExchangeRate;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Component;

import java.math.BigDecimal;

/**
 * @author: Scott
 * @Description:
 * @Date: Create in 10:34 2018/1/29
 */
@Component
@Slf4j
public class CurrencyRateUtils {

    @Autowired
    private RedisTemplate redisTemplate;


    public BigDecimal changeToRmb(String currency, BigDecimal num, String sourceName) {


        if("CNY".equals(currency)){
            return num;
        }

        ScExchangeRate exchangeRate = null;
        if (sourceName.equals(1)) {
            exchangeRate = (ScExchangeRate) redisTemplate.opsForValue().get("AKRATE-CNY" + currency);
        } else {
            exchangeRate = (ScExchangeRate) redisTemplate.opsForValue().get("RATE-CNY" + currency);

        }
        BigDecimal cny = new BigDecimal(0);

        if (exchangeRate != null) {
            Double finalRate = exchangeRate.getFinalRate();

            BigDecimal rate = new BigDecimal(finalRate);

            cny = num.multiply(rate).setScale(0, BigDecimal.ROUND_HALF_UP);

            return cny;
        } else {
            log.error("错误{}---------currency", currency);
            return null;
        }


    }


    public static void main(String[] args) {
        BigDecimal usd = new BigDecimal("3096000000");

        BigDecimal rate = new BigDecimal("0.0005");


        BigDecimal cny = usd.divide(rate, BigDecimal.ROUND_HALF_UP).setScale(0, BigDecimal.ROUND_HALF_UP);

        System.out.println(cny);


    }


}
