package com.bjlt.spider.utils;

import org.apache.commons.codec.Charsets;

import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;

/**
 * Created by Administrator on 2016/11/24.
 */
public final class Encrypt {


    /**
     * 加密
     *
     * @param content  需要加密的内容
     * @param password 加密密码
     * @return
     */
    public static String encrypt(String content, String password) throws Exception {
        try {

            byte[] raw = password.getBytes(Charsets.UTF_8);
            if (raw.length != 16) {
                throw new IllegalArgumentException("Invalid key size. " + password + ", 密钥token长度不是16位");
            }
            SecretKeySpec skeySpec = new SecretKeySpec(raw, "AES");
            Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
            cipher.init(Cipher.ENCRYPT_MODE, skeySpec, new IvParameterSpec(new byte[16])); // zero IV
            byte[] bytes = cipher.doFinal(content.getBytes(Charsets.UTF_8));
            return new String(org.apache.commons.codec.binary.Base64.encodeBase64(bytes));

        } catch (Exception e) {
            throw e;
        }
    }

    /**
     * 解密
     *
     * @param content  需要解密的内容
     * @param password 加密密码
     * @return
     */
    public static String decrypt(String content, String password) throws Exception {
        try {

            byte[] raw = password.getBytes(Charsets.UTF_8);
            if (raw.length != 16) {
                throw new IllegalArgumentException("Invalid key size. " + password + ", 密钥token长度不是16位");
            }
            SecretKeySpec skeySpec = new SecretKeySpec(raw, "AES");

            Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
            cipher.init(Cipher.DECRYPT_MODE, skeySpec, new IvParameterSpec(new byte[16]));
            byte[] toDecrypt = org.apache.commons.codec.binary.Base64.decodeBase64(content.getBytes());

            byte[] original = cipher.doFinal(toDecrypt);
            return new String(original, Charsets.UTF_8);

        }  catch (Exception e) {
            throw  e;
        }
    }




}
