package com.bjlt.spider.utils;

import java.io.*;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;
import java.nio.charset.Charset;
import java.util.Properties;

/**
 * Created by Administrator on 2016/11/23.
 */
public final class LoadParam {


    public static String read(InputStream inputStream) throws IOException {
        InputStreamReader isr = null;
        try {
            int length;
            char[] bs = new char[4096];
            StringBuilder out = new StringBuilder();

            isr = new InputStreamReader(inputStream, Charset.forName("UTF-8"));
            while ((length = isr.read(bs)) != -1) {
                out.append(bs, 0, length);
            }
            return out.toString();
        } finally {
            if (isr != null) {
                isr.close();
            }
        }
    }

    public static String read(InputStream inputStream, String password) throws Exception {
        return Encrypt.decrypt(read(inputStream), password);
    }

    public static String read(String fileName, String attribute) throws IOException {
        Properties properties = new Properties();
        InputStream resourceAsStream = LoadParam.class.getClassLoader().getResourceAsStream(fileName);
        properties.load(resourceAsStream);
        return properties.getProperty(attribute);
    }

    public static void main(String[] args) throws IOException {
        FileInputStream inputStream = new FileInputStream("F:\\travel.xml");
        FileChannel channel = inputStream.getChannel();
        ByteBuffer allocate = ByteBuffer.allocate(1050);
        while (true) {
            allocate.clear();
            int read = channel.read(allocate);
            if (read == -1) {
                break;
            }
            allocate.flip();
            System.out.println(allocate.array());
        }

    }

}
